--------------------------------------------------------------------------------
-- Random Instrument Selector
--------------------------------------------------------------------------------

sng = nil
tool = renoise.tool()

class "RandomInstrument"

function RandomInstrument:setupGlobalListeners()
  local newDocumentListener = function()
    sng = renoise.song()
  end
  
  if (not tool.app_new_document_observable:has_notifier(newDocumentListener)) then
    tool.app_new_document_observable:add_notifier(newDocumentListener)
  end
  
  if (type(renoise.song) == "function") then
    newDocumentListener()
  end
end

function RandomInstrument:selectRandomInstrument()
  local numInstr = 0
  local usedIndices = {}
  for instrIndex = 1, #sng.instruments do
    if (sng.instruments[instrIndex].name ~= '') then
      numInstr = numInstr + 1
      usedIndices[numInstr] = instrIndex
    end
  end
  sng.selected_instrument_index = usedIndices[math.random(numInstr)]
end

function RandomInstrument:__init()
  tool:add_keybinding {
    name = "Global:Tools:Select random instrument", 
    invoke =  function() self:selectRandomInstrument() end
  }
end


--------------------------------------------------------------------------------
-- Init
--------------------------------------------------------------------------------

inst = RandomInstrument()

idleListener = function ()
  tool.app_idle_observable:remove_notifier(idleListener)
  inst:setupGlobalListeners()
end
tool.app_idle_observable:add_notifier(idleListener)


